package biz.capitalware.mqfm.actions;

import biz.capitalware.mqfm.action.objects.DeleteObject;
import biz.capitalware.mqfm.handlers.IO;
import biz.capitalware.mqfm.objects.MQFMException;

/**
 * This class will handle the delete action.
 *
 * @author Roger Lacroix
 * @version 1.0
 * @license Apache 2 License
 */
public class DeleteAction extends FMAction
{
   private DeleteObject   ddo;

   /**
    * The constructor
    * @param ddo
    * @param logger
    */
   public DeleteAction(DeleteObject ddo)
   {
      super(ddo.actionName);
      this.ddo = ddo;
   }

   /**
    * Perform the delete work.
    */
   public int doWork()
   {
      int exitCode = 0;
      ddo.printValues();

      try
      {
         ddo.filenames = IO.buildStringArrayOfFiles(ddo.filenames);
         
         for (int i=0; i < ddo.filenames.length; i++)
         {
            IO.deleteFile(ddo.filenames[i]);
            ddo.fileCount++;
         }
      }
      catch (MQFMException e1)
      {
         if (ddo.onErrorFail)
            exitCode = 8;
      }

      return exitCode;
   }
}
