package biz.capitalware.mqfm.actions;

import java.io.IOException;

import org.jdom.JDOMException;

import com.ibm.mq.MQException;

import biz.capitalware.mqfm.MQFM;
import biz.capitalware.mqfm.action.objects.PutQuitObject;
import biz.capitalware.mqfm.mq.MQPutQuit;
import biz.capitalware.mqfm.mq.objects.MQObject;

public class PutQuitAction extends FMAction
{
   private PutQuitObject   pqo;
   private MQObject        mq;

   public PutQuitAction(PutQuitObject pqa)
   {
      super(pqa.actionName);
      this.pqo = pqa;
   }

   public int doWork()
   {
      int exitCode = 0;
      pqo.printValues();
      MQPutQuit mqh = null;

      try
      {
         mq = new MQObject(pqo.qMgrName, pqo.qObject, pqo.mqXMLFile, pqo.CCDTFile);

         mq.checkQM();

         mq.DumpUserParms();

         mqh = new MQPutQuit(mq);

         mqh.connect();

         mqh.simplePut1(pqo);
         pqo.msgCount++;
      }
      catch (JDOMException e)
      {
         MQFM.logger.fatal("JDOMException: " + e.getLocalizedMessage());
         if (e.getCause() != null)
            MQFM.logger.fatal(e.getCause().toString());;
         MQFM.globalErrorText = e.getLocalizedMessage();
         exitCode = 99;
      }
      catch (IOException e)
      {
         MQFM.logger.fatal("IOException: " + e.getLocalizedMessage());
         if (e.getCause() != null)
            MQFM.logger.fatal(e.getCause().toString());;
         MQFM.globalErrorText = e.getLocalizedMessage();
         exitCode = 99;
      }
      catch (MQException e)
      {
         MQFM.logger.fatal("MQException: " + e.getLocalizedMessage());
         if (e.getCause() != null)
            MQFM.logger.fatal("MQException: " + e.getCause());
         MQFM.logger.fatal("MQCC=" + e.completionCode + " : MQRC="+e.reasonCode);
         MQFM.globalErrorText = e.getLocalizedMessage();
         exitCode = 99;
      }
      catch (Exception e)
      {
         MQFM.logger.fatal("Exception: " + e.getLocalizedMessage());
         if (e.getCause() != null)
            MQFM.logger.fatal(e.getCause().toString());;
         MQFM.globalErrorText = e.getLocalizedMessage();
         exitCode = 99;
      }
      finally
      {
         if ( mqh != null)
            mqh.disconnect();
      }

      if (!pqo.onErrorFail)
         exitCode = 0; /* reset back to zero */

      return exitCode;
   }
}
