package biz.capitalware.mqfm.actions;

import biz.capitalware.mqfm.MQFM;
import biz.capitalware.mqfm.action.objects.SleepObject;

/**
 * This class will handle executing a command action.
 *
 * @author Roger Lacroix
 * @version 1.0
 * @license Apache 2 License
 */
public class SleepAction extends FMAction
{
   private SleepObject     so;

   public SleepAction(SleepObject so)
   {
      super(so.actionName);
      this.so = so;
   }

   /**
    * Perform schedule work.
    */
   public int doWork()
   {
      int exitCode = 0;
      so.printValues();

      long sleepTime = so.milliseconds + (so.seconds * 1000) + (so.minutes * 1000 * 60) + (so.hours * 1000 * 60 * 60); 
      
      try
      {
         MQFM.logger.info("Now sleeping for "+sleepTime+" milliseconds.");

        Thread.sleep(sleepTime); // time in milliseconds
      }
      catch (InterruptedException e) 
      {}

      if (!so.onErrorFail)
         exitCode = 0; /* reset back to zero */
      
      return exitCode;
   }
}
