package biz.capitalware.mqfm.actions;

import biz.capitalware.mqfm.action.objects.TouchObject;
import biz.capitalware.mqfm.handlers.IO;
import biz.capitalware.mqfm.objects.MQFMException;

/**
 * This class will handle the touch action.
 *
 * @author Roger Lacroix
 * @version 1.0
 * @license Apache 2 License
 */
public class TouchAction extends FMAction
{
   private TouchObject   to;

   /**
    * The constructor
    * @param to
    * @param logger
    */
   public TouchAction(TouchObject to)
   {
      super(to.actionName);
      this.to = to;
   }

   /**
    * Perform the touch work.
    */
   public int doWork()
   {
      int exitCode = 0;
      to.printValues();

      try
      {
         to.filenames = IO.buildStringArrayOfFiles(to.filenames);
         
         for (int i=0; i < to.filenames.length; i++)
         {
            IO.touchFile(to.filenames[i]);
            to.fileCount++;
         }
      }
      catch (MQFMException e1)
      {
         if (to.onErrorFail)
            exitCode = 8;
      }

      return exitCode;
   }
}
